Index: trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 609)
+++ trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 622)
@@ -120,5 +120,5 @@
     m_dmmWedgeTabIdx[i] = NULL;
   }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   m_dmm2DeltaEnd    = NULL;
 #endif
@@ -146,7 +146,4 @@
 #if H_3D_VSP
   m_piVSPFlag            = NULL;
-#if MTK_VSP_FIX_E0172
-  m_piVSPDir             = NULL;
-#endif
 #endif
 #if H_3D_ARP
@@ -200,7 +197,4 @@
 #if H_3D_VSP
     m_piVSPFlag          = (Char*  )xMalloc(Char,   uiNumPartition);
-#if MTK_VSP_FIX_E0172
-    m_piVSPDir           = (Char*  )xMalloc(Char,   uiNumPartition);
-#endif
 #endif
     m_puhLumaIntraDir    = (UChar* )xMalloc(UChar,  uiNumPartition);
@@ -280,5 +274,5 @@
       m_dmmWedgeTabIdx[i]    = (UInt*)xMalloc(UInt, uiNumPartition);
     }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
     m_dmm2DeltaEnd    = (Int* )xMalloc(Int,  uiNumPartition);
 #endif
@@ -363,7 +357,4 @@
 #if H_3D_VSP
     if ( m_piVSPFlag          ) { xFree(m_piVSPFlag);           m_piVSPFlag         = NULL; }
-#if MTK_VSP_FIX_E0172
-    if ( m_piVSPDir           ) { xFree(m_piVSPDir  );          m_piVSPDir          = NULL; }
-#endif
 #endif
     if ( m_puhLumaIntraDir    ) { xFree(m_puhLumaIntraDir);     m_puhLumaIntraDir   = NULL; }
@@ -419,5 +410,5 @@
       if ( m_dmmWedgeTabIdx[i] ) { xFree( m_dmmWedgeTabIdx[i] ); m_dmmWedgeTabIdx[i] = NULL; }
     }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
     if ( m_dmm2DeltaEnd    ) { xFree( m_dmm2DeltaEnd    ); m_dmm2DeltaEnd    = NULL; }
 #endif
@@ -573,7 +564,4 @@
 #if H_3D_VSP
     m_piVSPFlag[ui] = pcFrom->m_piVSPFlag[ui];
-#if MTK_VSP_FIX_E0172
-    m_piVSPDir  [ui] = pcFrom->m_piVSPDir[ui];
-#endif
 #endif
     m_puhLumaIntraDir[ui]=pcFrom->m_puhLumaIntraDir[ui];
@@ -618,7 +606,4 @@
 #if H_3D_VSP
     memset( m_piVSPFlag         + firstElement, 0,                        numElements * sizeof( *m_piVSPFlag ) );
-#if MTK_VSP_FIX_E0172
-    memset( m_piVSPDir          + firstElement, 0,                        numElements * sizeof( *m_piVSPDir   ) );
-#endif
 #endif
     memset( m_puhLumaIntraDir   + firstElement, DC_IDX,                   numElements * sizeof( *m_puhLumaIntraDir ) );
@@ -646,5 +631,5 @@
       memset( m_dmmWedgeTabIdx[i] + firstElement, 0,                      numElements * sizeof( *m_dmmWedgeTabIdx[i] ) );
     }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
     memset( m_dmm2DeltaEnd      + firstElement, 0,                        numElements * sizeof( *m_dmm2DeltaEnd    ) );
 #endif
@@ -802,7 +787,4 @@
 #if H_3D_VSP
       m_piVSPFlag[ui] = 0;
-#if MTK_VSP_FIX_E0172
-      m_piVSPDir  [ui] = 0;
-#endif
 #endif
       m_puhLumaIntraDir[ui] = DC_IDX;
@@ -829,5 +811,5 @@
         m_dmmWedgeTabIdx[i] [ui] = 0;
       }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
       m_dmm2DeltaEnd    [ui] = 0;
 #endif
@@ -906,7 +888,4 @@
 #if H_3D_VSP
   memset( m_piVSPFlag,          0, sizeof( Char  ) * m_uiNumPartition );
-#if MTK_VSP_FIX_E0172
-  memset( m_piVSPDir  ,         0, sizeInChar );
-#endif
 #endif
   memset( m_puhLumaIntraDir,    DC_IDX, iSizeInUchar );
@@ -946,5 +925,5 @@
     memset( m_dmmWedgeTabIdx[i], 0, sizeof(UInt) * m_uiNumPartition );
   }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   memset( m_dmm2DeltaEnd   , 0, sizeof(Int ) * m_uiNumPartition );
 #endif
@@ -1005,10 +984,5 @@
 #if H_3D_VSP
       m_piVSPFlag[ui]=pcCU->m_piVSPFlag[uiPartOffset+ui];
-#if MTK_VSP_FIX_ALIGN_WD_E0172
       m_pDvInfo[ ui ] = pcCU->m_pDvInfo[uiPartOffset+ui];
-#endif
-#if MTK_VSP_FIX_E0172
-      m_piVSPDir[ui]=pcCU->m_piVSPDir[uiPartOffset+ui];
-#endif
 #endif
       m_puhLumaIntraDir[ui]=pcCU->m_puhLumaIntraDir[uiPartOffset+ui];
@@ -1036,5 +1010,5 @@
         m_dmmWedgeTabIdx[i] [ui] = pcCU->m_dmmWedgeTabIdx[i] [uiPartOffset+ui];
       }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
       m_dmm2DeltaEnd    [ui] = pcCU->m_dmm2DeltaEnd   [uiPartOffset+ui];
 #endif
@@ -1162,7 +1136,4 @@
 #if H_3D_VSP
   m_piVSPFlag           = pcCU->getVSPFlag()          + uiPart;
-#if MTK_VSP_FIX_E0172
-  m_piVSPDir            = pcCU->getVSPDir  ()         + uiPart;
-#endif
 #endif
 
@@ -1196,5 +1167,5 @@
     m_dmmWedgeTabIdx[i] = pcCU->getDmmWedgeTabIdx( i ) + uiPart;
   }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   m_dmm2DeltaEnd    = pcCU->getDmm2DeltaEnd()    + uiPart;
 #endif
@@ -1321,10 +1292,5 @@
 #if H_3D_VSP
   m_piVSPFlag          = pcCU->getVSPFlag()               + uiAbsPartIdx;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
   m_pDvInfo            = pcCU->getDvInfo()                + uiAbsPartIdx;
-#endif
-#if MTK_VSP_FIX_E0172
-  m_piVSPDir           = pcCU->getVSPDir  ()              + uiAbsPartIdx;
-#endif
 #endif
 
@@ -1374,10 +1340,6 @@
 #if H_3D_VSP
   memcpy( m_piVSPFlag           + uiOffset, pcCU->getVSPFlag(),           sizeof( Char ) * uiNumPartition );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
   memcpy( m_pDvInfo             + uiOffset, pcCU->getDvInfo(),            sizeof( *m_pDvInfo ) * uiNumPartition );
-#endif
-#if MTK_VSP_FIX_E0172
-  memcpy( m_piVSPDir            + uiOffset, pcCU->getVSPDir  (),          sizeInChar );
-#endif
+
 #endif
   memcpy( m_puhLumaIntraDir     + uiOffset, pcCU->getLumaIntraDir(),      iSizeInUchar );
@@ -1404,5 +1366,5 @@
     memcpy( m_dmmWedgeTabIdx[i] + uiOffset, pcCU->getDmmWedgeTabIdx( i ), sizeof(UInt) * uiNumPartition );
   }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   memcpy( m_dmm2DeltaEnd    + uiOffset, pcCU->getDmm2DeltaEnd()   , sizeof(Int ) * uiNumPartition );
 #endif
@@ -1509,10 +1471,5 @@
 #if H_3D_VSP
   memcpy( rpcCU->getVSPFlag()           + m_uiAbsIdxInLCU, m_piVSPFlag,           sizeof( Char ) * m_uiNumPartition );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
   memcpy( rpcCU->getDvInfo()            + m_uiAbsIdxInLCU, m_pDvInfo,             sizeof( *m_pDvInfo ) * m_uiNumPartition );
-#endif
-#if MTK_VSP_FIX_E0172
-  memcpy( rpcCU->getVSPDir  ()          + m_uiAbsIdxInLCU, m_piVSPDir  ,          sizeInChar );
-#endif
 #endif
   memcpy( rpcCU->getLumaIntraDir()      + m_uiAbsIdxInLCU, m_puhLumaIntraDir,     iSizeInUchar );
@@ -1539,5 +1496,5 @@
     memcpy( rpcCU->getDmmWedgeTabIdx( i ) + m_uiAbsIdxInLCU, m_dmmWedgeTabIdx[i], sizeof(UInt) * m_uiNumPartition );
   }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   memcpy( rpcCU->getDmm2DeltaEnd()    + m_uiAbsIdxInLCU, m_dmm2DeltaEnd   , sizeof(Int ) * m_uiNumPartition );
 #endif
@@ -1632,7 +1589,4 @@
 #if H_3D_VSP
   memcpy( rpcCU->getVSPFlag()           + uiPartOffset, m_piVSPFlag,           sizeof(Char) * uiQNumPart );
-#if MTK_VSP_FIX_E0172
-  memcpy( rpcCU->getVSPDir  ()          + uiPartOffset, m_piVSPDir  ,          sizeInChar );
-#endif
 #endif
   memcpy( rpcCU->getLumaIntraDir()      + uiPartOffset, m_puhLumaIntraDir,     iSizeInUchar );
@@ -1658,5 +1612,5 @@
     memcpy( rpcCU->getDmmWedgeTabIdx( i ) + uiPartOffset, m_dmmWedgeTabIdx[i], sizeof(UInt) * uiQNumPart );
   }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   memcpy( rpcCU->getDmm2DeltaEnd()    + uiPartOffset, m_dmm2DeltaEnd   , sizeof(Int ) * uiQNumPart );
 #endif
@@ -2761,5 +2715,5 @@
   setSubPart<Char>( iVSPFlag, m_piVSPFlag, uiAbsPartIdx, uiDepth, uiPartIdx );
 }
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
 template<typename T>
 Void TComDataCU::setSubPartT( T uiParameter, T* puhBaseLCU, UInt uiCUAddr, UInt uiCUDepth, UInt uiPUIdx )
@@ -2895,10 +2849,4 @@
   }
 
-}
-#endif
-#if MTK_VSP_FIX_E0172
-Void TComDataCU::setVSPDirSubParts ( Char iVSPDir, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
-{
-  setSubPart<Char>( iVSPDir, m_piVSPDir, uiAbsPartIdx, uiDepth, uiPartIdx );
 }
 #endif
@@ -3355,58 +3303,39 @@
  *   false: otherwise
  */
-#if MTK_VSP_FIX_E0172
-inline Bool TComDataCU::xAddVspCand( UChar ucVspMergePos, Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
-                                    Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag, Int* vspDir )
-#else
-inline Bool TComDataCU::xAddVspCand( UChar ucVspMergePos, Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
+inline Bool TComDataCU::xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
                                      Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag )
-#endif
-{
-  if ( ucVspMergePos != H_3D_VSP_POSITION || 0 == m_pcSlice->getViewIndex() || !m_pcSlice->getVPS()->getViewSynthesisPredFlag( m_pcSlice->getLayerIdInVps() ) || m_pcSlice->getIsDepth() )
+{
+  if ( m_pcSlice->getViewIndex() == 0 || !m_pcSlice->getVPS()->getViewSynthesisPredFlag( m_pcSlice->getLayerIdInVps() ) || m_pcSlice->getIsDepth() )
+  {
     return false;
+  }
 
   Int refViewIdx = pDInfo->m_aVIdxCan;
   TComPic* picDepth = getSlice()->getIvPic( true, refViewIdx );
+  
   if( picDepth == NULL ) // No depth reference avail
+  {
+    // Is this allowed to happen? When not an assertion should be added here!
     return false;
-  
-  Bool refViewAvailFlag = false;
-  UChar predFlag[2] = {0, 0};
-  Int  iRefListIdX = 0;
-  Int  iRefListIdY = 0;
-  Int  i;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
-  Int currViewId = m_pcSlice->getViewId();
-  Int derivedViewId = -1;
-  Int otherViewId = -1;
-#endif
-#if MTK_VSP_FIX_E0172
-  Int currViewId = m_pcSlice->getViewId();
-  Int derivedViewId = -1;
-  Int otherViewId = -1;
-#endif
-  for( iRefListIdX = 0; iRefListIdX < 2 && !refViewAvailFlag; iRefListIdX++ )
-  {
-    RefPicList eRefPicList = RefPicList( iRefListIdX );
-    for ( i = 0; i < m_pcSlice->getNumRefIdx(eRefPicList) && !refViewAvailFlag; i++ )
-    {
-      Int viewIdxRefInList = m_pcSlice->getRefPic(eRefPicList, i)->getViewIndex();
-      if ( viewIdxRefInList == refViewIdx )
-      {
-        refViewAvailFlag = true;
+  }
+  
+  Bool  refViewAvailFlag = false;
+  UChar predFlag[2]      = {0, 0};  
+  Int   refListIdY       = 0;    
+  Int   viewIdInRefListX = -1;
+  
+  for( Int iRefListIdX = 0; iRefListIdX < 2 && !refViewAvailFlag; iRefListIdX++ )
+  {
+    RefPicList eRefPicListX = RefPicList( iRefListIdX );
+    for ( Int i = 0; i < m_pcSlice->getNumRefIdx(eRefPicListX) && !refViewAvailFlag; i++ )
+    {
+      Int viewIdxRefInListX = m_pcSlice->getRefPic(eRefPicListX, i)->getViewIndex();
+      if ( viewIdxRefInListX == refViewIdx )
+      {
+        refViewAvailFlag      = true;
         predFlag[iRefListIdX] = 1;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
-        derivedViewId = m_pcSlice->getRefPic(eRefPicList, i)->getViewId();
-#endif
-#if MTK_VSP_FIX_E0172
-        vspDir[iCount] = iRefListIdX;
-        derivedViewId = m_pcSlice->getRefPic(eRefPicList, i)->getViewId(); 
-#endif
-        iRefListIdY = 1 - iRefListIdX;
-#if H_3D_FIX_BVSP
+        viewIdInRefListX      = m_pcSlice->getRefPic(eRefPicListX, i)->getViewId();
+        refListIdY            = 1 - iRefListIdX;
         pcMvFieldNeighbours[(iCount<<1)+iRefListIdX].setMvField( pDInfo->m_acNBDV, i );
-#else
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdX].setMvField( pDInfo->m_acDoNBDV, i );
-#endif
 #if H_3D_NBDV
         pcMvFieldNeighbours[(iCount<<1)+iRefListIdX].getMv().setIDVFlag (false);
@@ -3418,21 +3347,24 @@
   if (m_pcSlice->isInterB() && refViewAvailFlag)
   {
-    RefPicList eRefPicList = RefPicList( iRefListIdY );
+    RefPicList eRefPicListY = RefPicList( refListIdY );
     refViewAvailFlag = false;
-    for ( i = 0; i < m_pcSlice->getNumRefIdx(eRefPicList) && !refViewAvailFlag; i++ )
-    {
-      Int viewIdxRefInList = m_pcSlice->getRefPic(eRefPicList, i)->getViewIndex();
-      if ( viewIdxRefInList != refViewIdx && viewIdxRefInList != m_pcSlice->getViewIndex() )
+    for ( Int i = 0; i < m_pcSlice->getNumRefIdx(eRefPicListY) && !refViewAvailFlag; i++ )
+    {
+      Int viewIdxRefInListY = m_pcSlice->getRefPic(eRefPicListY, i)->getViewIndex();
+      if ( viewIdxRefInListY != refViewIdx && viewIdxRefInListY != m_pcSlice->getViewIndex() )
       {
         refViewAvailFlag = true;
-        predFlag[iRefListIdY] = 1;
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
-#if H_3D_FIX_BVSP
+        predFlag[refListIdY] = 1;
         TComMv  cMv = pDInfo->m_acNBDV;
-#else
-        TComMv  cMv = pDInfo->m_acDoNBDV;
-#endif
-        otherViewId = m_pcSlice->getRefPic( eRefPicList, i)->getViewId();
-        Int iScale = xGetDistScaleFactor( currViewId, otherViewId, currViewId, derivedViewId );
+        
+        Int viewIdInRefListY = m_pcSlice->getRefPic( eRefPicListY, i)->getViewId();
+        Int currViewId       = m_pcSlice->getViewId();
+        
+        //// Following might be added here when MV-HEVC 5 HLS is included (and derivations above removed): 
+        // Int viewIdInRefListX = m_pcSlice->getVPS()->getViewIdVal( refViewIdx  ); 
+        
+        Int iScale      = xGetDistScaleFactor( currViewId, viewIdInRefListY, currViewId, viewIdInRefListX );
+        
+        // Can iScale == 4096 happen?, I guess not since viewIdInRefListY is always unequal to viewIdInRefListX.
         if ( iScale != 4096 && m_pcSlice->getVPS()->getIvMvScalingFlag() ) 
         {
@@ -3445,14 +3377,7 @@
         }
         clipMv( cMv );
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdY].setMvField( cMv, i );
-#else
-#if H_3D_FIX_BVSP
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdY].setMvField( pDInfo->m_acNBDV, i );
-#else
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdY].setMvField( pDInfo->m_acDoNBDV, i );
-#endif
-#endif
+        pcMvFieldNeighbours[(iCount<<1)+refListIdY].setMvField( cMv, i );
 #if H_3D_NBDV
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdY].getMv().setIDVFlag (false);
+        pcMvFieldNeighbours[(iCount<<1)+refListIdY].getMv().setIDVFlag (false);
 #endif
       }
@@ -3461,10 +3386,12 @@
 
   // Set values to be returned
-  abCandIsInter[iCount] = true;
+  abCandIsInter        [iCount] = true;
   puhInterDirNeighbours[iCount] = (predFlag[0] | (predFlag[1] << 1));
-  vspFlag[iCount] = 1;
+  vspFlag              [iCount] = 1;
 
   if ( mrgCandIdx == iCount )
+  {
     return true;
+  }
 
   iCount++;
@@ -3475,14 +3402,15 @@
 #endif
 
-#if QC_INRIA_MTK_MRG_E0126
-inline Bool TComDataCU::xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int*   iPdmDir, TComMv* acPdmMv, 
-                                       Int* aiPdmRefIdx, Int iPosDmv, Int* vspFlag )
-{
-  for(Int iLoop = 0; iLoop  < 2; iLoop ++ ) 
-  {
+#if H_3D_IV_MERGE
+inline Bool TComDataCU::xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* ivCandDir, TComMv* ivCandMv, 
+                                       Int* ivCandRefIdx, Int iPosIvDC, Int* vspFlag )
+{
+  for(Int iLoop = 0; iLoop < 2; iLoop ++ ) 
+  {
+    // IvDcShift (Derived from spatial Iv neighboring blocks)
     if( iLoop == 1 )
     {
       Int iFirDispCand = -1;
-      if (xFirstDmvAvai(iCount, pcMvFieldNeighbours, iPdmDir, iPosDmv, vspFlag, iFirDispCand))
+      if (xGetPosFirstAvailDmvCand(iCount, pcMvFieldNeighbours, ivCandDir, iPosIvDC, vspFlag, iFirDispCand))
       {
         TComMv cMv;
@@ -3494,40 +3422,46 @@
         }
         clipMv( cMv );
-        abCandIsInter[ iCount ] = true;
+        abCandIsInter        [ iCount ] = true;
         puhInterDirNeighbours[ iCount ] = puhInterDirNeighbours[iFirDispCand];
-        pcMvFieldNeighbours[ iCount<<1  ].setMvField(cMv, pcMvFieldNeighbours[( iFirDispCand << 1)].getRefIdx() );
-        pcMvFieldNeighbours[ (iCount<<1)+1 ].setMvField(pcMvFieldNeighbours[(iFirDispCand << 1) + 1].getMv(), pcMvFieldNeighbours[( iFirDispCand << 1) + 1].getRefIdx() );
+        pcMvFieldNeighbours  [ iCount << 1      ].setMvField(cMv, pcMvFieldNeighbours[( iFirDispCand << 1)].getRefIdx() );
+        pcMvFieldNeighbours  [(iCount << 1) + 1 ].setMvField(pcMvFieldNeighbours[(iFirDispCand << 1) + 1].getMv(), pcMvFieldNeighbours[( iFirDispCand << 1) + 1].getRefIdx() );
+        
         if( mrgCandIdx == iCount ) 
         {
           return true;
         }
+
         iCount++;
         break;
       }
     }
-    if(iPdmDir[iLoop + 2])
-    {
-      abCandIsInter[ iCount ] = true;
-      puhInterDirNeighbours[ iCount ] = iPdmDir[iLoop + 2];
-      if( ( iPdmDir[iLoop + 2] & 1 ) == 1 )
-      {
-        pcMvFieldNeighbours[ iCount<<1 ].setMvField( acPdmMv[ (iLoop<<1) + 4 ], aiPdmRefIdx[ (iLoop<<1) + 4 ] ); 
-      }
-      if( ( iPdmDir[iLoop + 2] & 2 ) == 2 )
-      {
-        pcMvFieldNeighbours[ (iCount<<1)+1 ].setMvField( acPdmMv[ (iLoop<<1) + 5 ], aiPdmRefIdx[ (iLoop<<1) + 5 ] );
+
+    /// iLoop = 0 --> IvMCShift
+    /// iLoop = 1 --> IvDCShift  (Derived from IvDC)
+    if(ivCandDir[iLoop + 2])
+    {
+      abCandIsInter        [ iCount ] = true;
+      puhInterDirNeighbours[ iCount ] = ivCandDir[iLoop + 2];
+      if( ( ivCandDir[iLoop + 2] & 1 ) == 1 )
+      {
+        pcMvFieldNeighbours[ iCount<<1 ].setMvField( ivCandMv[ (iLoop<<1) + 4 ], ivCandRefIdx[ (iLoop<<1) + 4 ] ); 
+      }
+      if( ( ivCandDir[iLoop + 2] & 2 ) == 2 )
+      {
+        pcMvFieldNeighbours[ (iCount<<1)+1 ].setMvField( ivCandMv[ (iLoop<<1) + 5 ], ivCandRefIdx[ (iLoop<<1) + 5 ] );
       }
      
-      bool bRemove = false;
-      if(!iLoop && iPdmDir[0] > 0)
-      {
-        if(puhInterDirNeighbours[iCount] == puhInterDirNeighbours[0] && pcMvFieldNeighbours[0]==pcMvFieldNeighbours[(iCount<<1)] && pcMvFieldNeighbours[1]==pcMvFieldNeighbours[(iCount<<1)+1])
+      // Prune IvMC vs. IvMcShift
+      Bool bRemove = false;      
+      if( !iLoop && ivCandDir[0] > 0)
+      {
+        if(puhInterDirNeighbours[iCount] == puhInterDirNeighbours[0] && pcMvFieldNeighbours[0 ]== pcMvFieldNeighbours[(iCount<<1)] && pcMvFieldNeighbours[1]==pcMvFieldNeighbours[(iCount<<1)+1])
         {
-            bRemove                      = true;
+            bRemove                         = true;
             abCandIsInter        [ iCount ] = false;  
-            puhInterDirNeighbours[iCount]   = 0;
+            puhInterDirNeighbours[ iCount ] = 0;
             TComMv  cZeroMv;
-            pcMvFieldNeighbours[iCount<<1].setMvField( cZeroMv, NOT_VALID );
-            pcMvFieldNeighbours[(iCount<<1)+1].setMvField( cZeroMv, NOT_VALID );
+            pcMvFieldNeighbours  [ iCount<<1   ].setMvField( cZeroMv, NOT_VALID );
+            pcMvFieldNeighbours  [(iCount<<1)+1].setMvField( cZeroMv, NOT_VALID );
         }
       }
@@ -3535,5 +3469,5 @@
       {
 #if H_3D_NBDV
-        if(iLoop)
+        if(iLoop) // For IvMcShift candidate
         {
           pcMvFieldNeighbours[iCount<<1    ].getMv().setIDVFlag (false);
@@ -3553,15 +3487,16 @@
 } 
 
-inline Bool TComDataCU::xFirstDmvAvai( Int& iCount, TComMvField* pcMvFieldNeighbours, Int* iPdmDir, Int iPosDmv, Int* vspFlag, Int& iFirDispCand )
-{
-  for ( Int i = (iPdmDir[0] ? 1: 0); i < iCount; i++ )
-  {
-    if ( ( i == iPosDmv ) || ( vspFlag[ i ] == 1 ) )
+inline Bool TComDataCU::xGetPosFirstAvailDmvCand( Int iCount, TComMvField* pcMvFieldNeighbours, Int* ivCandDir, Int posIvDC, Int* vspFlag, Int& posFirstAvailDmvCand )
+{
+  // ivCandDir[0] == true --> IvMC is available and excluded in loop over merge list. 
+  for ( Int currListPos = (ivCandDir[0] ? 1 : 0); currListPos < iCount; currListPos++ )
+  {
+    if ( ( currListPos == posIvDC ) || ( vspFlag[ currListPos ] == 1 ) )
     {
       continue;
     }
-    else if((pcMvFieldNeighbours[i<<1].getRefIdx()!=-1) && (getSlice()->getViewIndex() != getSlice()->getRefPic(RefPicList(0), pcMvFieldNeighbours[i<<1].getRefIdx())->getViewIndex()))
-    {
-      iFirDispCand = i;
+    else if((pcMvFieldNeighbours[currListPos<<1].getRefIdx() != -1 ) && (getSlice()->getViewIndex() != getSlice()->getRefPic(RefPicList(0), pcMvFieldNeighbours[currListPos<<1].getRefIdx())->getViewIndex()))
+    {
+      posFirstAvailDmvCand = currListPos;
       return true;
     }
@@ -3582,10 +3517,5 @@
 #if H_3D_VSP
       , Int* vspFlag
-#if MTK_VSP_FIX_ALIGN_WD_E0172
       , InheritedVSPDisInfo*  inheritedVSPDisInfo
-#endif
-#if MTK_VSP_FIX_E0172
-      , Int* vspDir
-#endif
 #endif
       , Int& numValidMergeCand, Int mrgCandIdx
@@ -3594,4 +3524,7 @@
   UInt uiAbsPartAddr = m_uiAbsIdxInLCU + uiAbsPartIdx;
 #if H_3D_IV_MERGE
+  ////////////////////////////
+  //////// INIT LISTS ////////
+  ////////////////////////////
   TComMv cZeroMv;
   Bool abCandIsInter[ MRG_MAX_NUM_CANDS_MEM ];
@@ -3611,4 +3544,9 @@
   }
   numValidMergeCand = getSlice()->getMaxNumMergeCand();
+#if H_3D
+  //////////////////////////////////
+  //////// DERIVE LOCATIONS ////////
+  //////////////////////////////////
+#endif
   // compute the location of the current PU
   Int xP, yP, nPSW, nPSH;
@@ -3622,33 +3560,9 @@
   deriveLeftBottomIdxGeneral  ( uiAbsPartIdx, uiPUIdx, uiPartIdxLB );
 #if H_3D_IV_MERGE
-  Bool ivMvPredFlag   = getSlice()->getVPS()->getIvMvPredFlag( getSlice()->getLayerIdInVps() );
-
-  //===== add merge with predicted depth maps =====
-#if QC_INRIA_MTK_MRG_E0126
-  TComMv acPdmMv         [8];
-  Int aiPdmRefIdx        [8] = {-1, -1, -1, -1, -1, -1, -1, -1};
-  Int iPosDmv                = -1;
-#else 
-  TComMv  acPdmMv       [4];
-  Int     aiPdmRefIdx   [4] = {-1, -1, -1, -1};
-#endif
-  Bool    bLeftAvai         = false;
-  Int     iPosLeftAbove[2]  = {-1, -1};
-
-
-  DisInfo cDisInfo;
-
-  cDisInfo.bDV = getDvInfo(uiAbsPartIdx).bDV;
-#if H_3D_NBDV_REF
-  cDisInfo.m_acDoNBDV = getDvInfo(uiAbsPartIdx).m_acDoNBDV;
-#endif //H_3D_NBDV_REF
-  cDisInfo.m_acNBDV = getDvInfo(uiAbsPartIdx).m_acNBDV;
-  cDisInfo.m_aVIdxCan = getDvInfo(uiAbsPartIdx).m_aVIdxCan;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
-  for(Int i = 0; i < MRG_MAX_NUM_CANDS_MEM; i++)
-  {
-    inheritedVSPDisInfo[i].m_acDvInfo = cDisInfo;
-  }
-#endif
+  
+  /////////////////////////////////////////////
+  //////// TEXTURE MERGE CANDIDATE (T) ////////
+  /////////////////////////////////////////////
+
   if( m_pcSlice->getIsDepth())
   {
@@ -3659,5 +3573,4 @@
     if ( pcTextureCU && !pcTextureCU->isIntra( uiPartIdxCenter ) )
     {
-#if MTK_TEXTURE_MRGCAND_BUGFIX_E0182
       pcTextureCU->getMvField( pcTextureCU, uiPartIdxCenter, REF_PIC_LIST_0, pcMvFieldNeighbours[iCount<<1] );
       Int iValidDepRef = getPic()->isTextRefValid( REF_PIC_LIST_0, pcMvFieldNeighbours[iCount<<1].getRefIdx() );
@@ -3699,96 +3612,58 @@
         iCount ++;
       }
-#else
-      abCandIsInter[iCount] = true;      
-      puhInterDirNeighbours[iCount] = pcTextureCU->getInterDir( uiPartIdxCenter );
-#if MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170
-      pcTextureCU->getMvField( pcTextureCU, uiPartIdxCenter, REF_PIC_LIST_0, pcMvFieldNeighbours[iCount<<1] );
-      if (pcMvFieldNeighbours[iCount<<1].getRefIdx()>=0)
-#else
-      if( ( puhInterDirNeighbours[iCount] & 1 ) == 1 )
-#endif
-      {
-#if !MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170
-        pcTextureCU->getMvField( pcTextureCU, uiPartIdxCenter, REF_PIC_LIST_0, pcMvFieldNeighbours[iCount<<1] );
-#endif
-        TComMv cMvPred = pcMvFieldNeighbours[iCount<<1].getMv();
-
-#if H_3D_IC
-        const TComMv cAdd( 1 << ( 2 - 1 ), 1 << ( 2 - 1 ) );
-        cMvPred+=cAdd;
-        cMvPred>>=2;
-        clipMv(cMvPred);
-#endif
-        //pcMvFieldNeighbours[iCount<<1].setMvField(cMvPred,pcMvFieldNeighbours[iCount<<1].getRefIdx());
-#if H_3D //Notes from QC: for BVSP coded blocks, the reference index shall not be equal to -1 due to the adoption of JCT3V-D0191
-        pcMvFieldNeighbours[iCount<<1].setMvField(cMvPred,pcMvFieldNeighbours[iCount<<1].getRefIdx());
-#endif
-      }
-      
-      if ( getSlice()->isInterB() )
-      {
-#if MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170
-        pcTextureCU->getMvField( pcTextureCU, uiPartIdxCenter, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
-        if (pcMvFieldNeighbours[(iCount<<1)+1].getRefIdx()>=0)
-#else
-        if( ( puhInterDirNeighbours[iCount] & 2 ) == 2 )
-#endif
-        {
-#if !MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170
-          pcTextureCU->getMvField( pcTextureCU, uiPartIdxCenter, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
-#endif
-          TComMv cMvPred = pcMvFieldNeighbours[(iCount<<1)+1].getMv();
-#if H_3D_IC
-          const TComMv cAdd( 1 << ( 2 - 1 ), 1 << ( 2 - 1 ) );
-          cMvPred+=cAdd;
-          cMvPred>>=2;
-          clipMv(cMvPred);
-#endif
-          pcMvFieldNeighbours[(iCount<<1)+1].setMvField(cMvPred,pcMvFieldNeighbours[(iCount<<1)+1].getRefIdx());
-        }
-      }
-#if MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170
-      puhInterDirNeighbours[iCount] = (pcMvFieldNeighbours[iCount<<1].getRefIdx()>=0)?1:0;
-      puhInterDirNeighbours[iCount] += (pcMvFieldNeighbours[(iCount<<1)+1].getRefIdx()>=0)?2:0;
-#endif
-#if H_3D_NBDV
-      pcMvFieldNeighbours[iCount<<1    ].getMv().setIDVFlag (false);
-      pcMvFieldNeighbours[(iCount<<1)+1].getMv().setIDVFlag (false);
-#endif
-      if ( mrgCandIdx == iCount )
-      {
-        return;
-      }
-      iCount ++;
-#endif//Bug fix
-    }
-  }
-
-#if QC_INRIA_MTK_MRG_E0126
-  Int iPdmDir[4] = {0, 0, 0, 0};
-#else
-  Int iPdmDir[2] = {0, 0};
-#endif
+    }
+  }
+
+  //////////////////////////////////
+  //////// GET DISPARITIES  ////////
+  //////////////////////////////////
+
+  DisInfo cDisInfo = getDvInfo(uiAbsPartIdx);
+
+  for(Int i = 0; i < MRG_MAX_NUM_CANDS_MEM; i++)
+  {
+    inheritedVSPDisInfo[i].m_acDvInfo = cDisInfo;
+  }
+
+  /////////////////////////////////////////////////////////////////
+  //////// DERIVE IvMC, IvMCShift,IvDCShift, IvDC  Candidates /////
+  /////////////////////////////////////////////////////////////////
+
+  Int  posIvDC          = -1;
+  Bool bLeftAvai        = false;
+  Int  iPosLeftAbove[2] = {-1, -1};
+
+
+  // { IvMCL0, IvMCL1, IvDCL0, IvDCL1, IvMCL0Shift, IvMCL1Shift, IvDCL0Shift, IvDCL1Shift };  
+  // An enumerator would be appropriate here! 
+  TComMv ivCandMv    [8];
+  Int    ivCandRefIdx[8] = {-1, -1, -1, -1, -1, -1, -1, -1};
+
+  // { IvMC, IvDC, IvMCShift, IvDCShift };  
+  Int    ivCandDir   [4] = {0, 0, 0, 0};
+
+  Bool ivMvPredFlag   = getSlice()->getVPS()->getIvMvPredFlag( getSlice()->getLayerIdInVps() );
   
   if ( ivMvPredFlag )
   {
-    getInterViewMergeCands(uiPUIdx, aiPdmRefIdx, acPdmMv, &cDisInfo, iPdmDir );
+    getInterViewMergeCands(uiPUIdx, ivCandRefIdx, ivCandMv, &cDisInfo, ivCandDir );
   }  
-    
-  Int iPdmInterDir;
-
-  if( iPdmDir[0] )
+  
+  ///////////////////////////////////////////////
+  //////// INTER VIEW MOTION COMP(IvMC) /////////
+  ///////////////////////////////////////////////
+
+  if( ivCandDir[0] )
   {
     abCandIsInter        [ iCount ] = true;
-    puhInterDirNeighbours[ iCount ] = iPdmDir[0];
-    iPdmInterDir                    = iPdmDir[0];
-
-    if( ( iPdmInterDir & 1 ) == 1 )
-    {
-      pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 0 ], aiPdmRefIdx[ 0 ] );
-    }
-    if( ( iPdmInterDir & 2 ) == 2 )
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 1 ], aiPdmRefIdx[ 1 ] );
+    puhInterDirNeighbours[ iCount ] = ivCandDir[0];    
+
+    if( ( ivCandDir[0] & 1 ) == 1 )
+    {
+      pcMvFieldNeighbours[ iCount<<1    ].setMvField( ivCandMv[ 0 ], ivCandRefIdx[ 0 ] );
+    }
+    if( ( ivCandDir[0] & 2 ) == 2 )
+    {
+      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( ivCandMv[ 1 ], ivCandRefIdx[ 1 ] );
     }
 
@@ -3799,4 +3674,5 @@
     iCount ++;
   } 
+
   // early termination
   if (iCount == getSlice()->getMaxNumMergeCand()) 
@@ -3806,4 +3682,9 @@
 #endif
 
+#if H_3D
+  ////////////////////////////
+  //////// LEFT (A1) /////////
+  ////////////////////////////
+#endif
   //left
   UInt uiLeftPartIdx = 0;
@@ -3852,17 +3733,9 @@
 #if H_3D_VSP
       if (pcCULeft->getVSPFlag(uiLeftPartIdx) == 1)
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
-      {
-#endif
+      {
         vspFlag[iCount] = 1;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
         xInheritVSPDisInfo(pcCULeft,uiLeftPartIdx,iCount,inheritedVSPDisInfo);
       }
 #endif
-#if MTK_VSP_FIX_E0172
-        vspDir[iCount] = pcCULeft->getVSPDir( uiLeftPartIdx );
-      }
-#endif
-#endif
       if ( mrgCandIdx == iCount )
       {
@@ -3871,5 +3744,5 @@
       iCount ++;
     }
-#else
+#else // H_3D_IV_MERGE 
     if ( mrgCandIdx == iCount )
     {
@@ -3877,5 +3750,5 @@
     }
     iCount ++;
-#endif
+#endif // H_3D_IV_MERGE 
   }
   
@@ -3885,4 +3758,9 @@
     return;
   }
+#if H_3D
+  ////////////////////////////
+  //////// ABOVE (B1) ////////
+  ////////////////////////////
+#endif
   // above
   UInt uiAbovePartIdx = 0;
@@ -3917,9 +3795,10 @@
         puhInterDirNeighbours[iCount]   = 0;
 
-        pcMvFieldNeighbours[iCount<<1].setMvField( cZeroMv, NOT_VALID );
+        pcMvFieldNeighbours[iCount<<1]    .setMvField( cZeroMv, NOT_VALID );
         pcMvFieldNeighbours[(iCount<<1)+1].setMvField( cZeroMv, NOT_VALID );
         break;
       }
     }
+
     if(!bRemoveSpa)
     {
@@ -3931,17 +3810,10 @@
 #if H_3D_VSP
       if (pcCUAbove->getVSPFlag(uiAbovePartIdx) == 1)
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
-      {
-#endif
+      {
+
         vspFlag[iCount] = 1;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
         xInheritVSPDisInfo(pcCUAbove,uiAbovePartIdx,iCount,inheritedVSPDisInfo);
       }
 #endif
-#if MTK_VSP_FIX_E0172
-        vspDir[iCount] = pcCUAbove->getVSPDir( uiAbovePartIdx );
-      }
-#endif
-#endif
       if ( mrgCandIdx == iCount )
       {
@@ -3950,5 +3822,5 @@
       iCount ++;
     }
-#else
+#else // H_3D_IV_MERGE 
     if ( mrgCandIdx == iCount )
     {
@@ -3956,5 +3828,5 @@
     }
     iCount ++;
-#endif
+#endif // H_3D_IV_MERGE 
   }
   // early termination
@@ -3963,4 +3835,10 @@
     return;
   }
+
+#if H_3D
+  //////////////////////////////////
+  //////// ABOVE RIGHT (B0) ////////
+  //////////////////////////////////
+#endif
 
   // above right
@@ -3988,16 +3866,8 @@
 #if H_3D_VSP
     if (pcCUAboveRight->getVSPFlag(uiAboveRightPartIdx) == 1)
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
-    {
-#endif
+    {
       vspFlag[iCount] = 1;
-#if MTK_VSP_FIX_ALIGN_WD_E0172
       xInheritVSPDisInfo(pcCUAboveRight,uiAboveRightPartIdx,iCount,inheritedVSPDisInfo);
     }
-#endif
-#if MTK_VSP_FIX_E0172
-      vspDir[iCount] = pcCUAboveRight->getVSPDir( uiAboveRightPartIdx);
-    }
-#endif
 #endif
     if ( mrgCandIdx == iCount )
@@ -4014,16 +3884,20 @@
 
 #if H_3D_IV_MERGE 
-  if( iPdmDir[1] )
+  /////////////////////////////////////////////
+  //////// INTER VIEW DISP COMP (IvDC) ////////
+  /////////////////////////////////////////////
+
+  if( ivCandDir[1] )
   {
     assert(iCount < getSlice()->getMaxNumMergeCand());
     abCandIsInter        [ iCount ] = true;
-    puhInterDirNeighbours[ iCount ] = iPdmDir[1];
-    if( ( iPdmDir[1] & 1 ) == 1 )
-    {
-      pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 2 ], aiPdmRefIdx[ 2 ] );
-    }
-    if( ( iPdmDir[1] & 2 ) == 2 )
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 3 ], aiPdmRefIdx[ 3 ] );
+    puhInterDirNeighbours[ iCount ] = ivCandDir[1];
+    if( ( ivCandDir[1] & 1 ) == 1 )
+    {
+      pcMvFieldNeighbours[ iCount<<1    ].setMvField( ivCandMv[ 2 ], ivCandRefIdx[ 2 ] );
+    }
+    if( ( ivCandDir[1] & 2 ) == 2 )
+    {
+      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( ivCandMv[ 3 ], ivCandRefIdx[ 3 ] );
     }
 
@@ -4032,6 +3906,8 @@
     {
       Int iCnloop = iPosLeftAbove[i];
-      if(iCnloop == -1) 
+      if ( iCnloop == -1 ) 
+      {
         continue;
+      }
       if(puhInterDirNeighbours[iCount] == puhInterDirNeighbours[iCnloop] && pcMvFieldNeighbours[iCnloop<<1]==pcMvFieldNeighbours[(iCount<<1)] && pcMvFieldNeighbours[(iCnloop<<1)+1]==pcMvFieldNeighbours[(iCount<<1)+1])
       {
@@ -4051,7 +3927,5 @@
       pcMvFieldNeighbours[(iCount<<1)+1].getMv().setIDVFlag (false);
 #endif
-#if QC_INRIA_MTK_MRG_E0126
-      iPosDmv  = iCount;
-#endif
+      posIvDC  = iCount;
       if ( mrgCandIdx == iCount )
         return;
